// This file is auto-generated by OmiLAXR.SceneManagement.Editor.SceneEnumGenerator.cs
// Changes to this file will be overwritten the next time this file is regenerated.

using UnityEngine;
using System.Collections.Generic;
using UnityEngine.SceneManagement;

namespace OmiLAXR.SceneManagement.Runtime
{
    public enum OmiLAXRScene
    {
        None = -1,
        _RePiX_VR_Desktop = 0,
        _RePiX_Dev_Environment = 1,
        _0_LanguageSelection = 2,
        _0_Tutorial = 3,
        _1_RP_Introduction = 4,
        _2_Application_Stage = 5,
        _3_3D_Geometry_Stage = 6,
        _4_3D_Transformation_Stage = 7,
        _5_Clipping_Stage = 8,
        _6_1_Rasterization_Stage = 9,
        _6_2_Rasterization_Stage = 10,
        _7_1_Lighting = 11,
        _7_2_Lighting = 12,
        _8_1_Texturing_Stage = 13,
        _8_2_Texturing_Stage = 14,
        _9_Visibility_Test_Stage = 15,
        _10_Image_Stage = 16,
    }


    public static class OmiLAXRSceneExtensions
    {
        private static readonly Dictionary<OmiLAXRScene, string> Paths = new Dictionary<OmiLAXRScene, string>();
        private static readonly Dictionary<OmiLAXRScene, int> Indices = new Dictionary<OmiLAXRScene, int>();


        static OmiLAXRSceneExtensions()
        {
            Paths.Add(OmiLAXRScene.None, null);
            Indices.Add(OmiLAXRScene.None, -1);

            Paths.Add(OmiLAXRScene._RePiX_VR_Desktop, "Assets/RePiX_VR/Resources/Scenes/RePiX_VR_Desktop.unity");
            Indices.Add(OmiLAXRScene._RePiX_VR_Desktop, 0);

            Paths.Add(OmiLAXRScene._RePiX_Dev_Environment, "Assets/RePiX_VR/Resources/Scenes/RePiX_Dev_Environment.unity");
            Indices.Add(OmiLAXRScene._RePiX_Dev_Environment, 1);

            Paths.Add(OmiLAXRScene._0_LanguageSelection, "Assets/RePiX_VR/Resources/Scenes/Stages/0. LanguageSelection.unity");
            Indices.Add(OmiLAXRScene._0_LanguageSelection, 2);

            Paths.Add(OmiLAXRScene._0_Tutorial, "Assets/RePiX_VR/Resources/Scenes/Stages/0. Tutorial.unity");
            Indices.Add(OmiLAXRScene._0_Tutorial, 3);

            Paths.Add(OmiLAXRScene._1_RP_Introduction, "Assets/RePiX_VR/Resources/Scenes/Stages/1. RP Introduction.unity");
            Indices.Add(OmiLAXRScene._1_RP_Introduction, 4);

            Paths.Add(OmiLAXRScene._2_Application_Stage, "Assets/RePiX_VR/Resources/Scenes/Stages/2. Application Stage.unity");
            Indices.Add(OmiLAXRScene._2_Application_Stage, 5);

            Paths.Add(OmiLAXRScene._3_3D_Geometry_Stage, "Assets/RePiX_VR/Resources/Scenes/Stages/3. 3D Geometry Stage.unity");
            Indices.Add(OmiLAXRScene._3_3D_Geometry_Stage, 6);

            Paths.Add(OmiLAXRScene._4_3D_Transformation_Stage, "Assets/RePiX_VR/Resources/Scenes/Stages/4. 3D Transformation Stage.unity");
            Indices.Add(OmiLAXRScene._4_3D_Transformation_Stage, 7);

            Paths.Add(OmiLAXRScene._5_Clipping_Stage, "Assets/RePiX_VR/Resources/Scenes/Stages/5. Clipping Stage.unity");
            Indices.Add(OmiLAXRScene._5_Clipping_Stage, 8);

            Paths.Add(OmiLAXRScene._6_1_Rasterization_Stage, "Assets/RePiX_VR/Resources/Scenes/Stages/6.1. Rasterization Stage.unity");
            Indices.Add(OmiLAXRScene._6_1_Rasterization_Stage, 9);

            Paths.Add(OmiLAXRScene._6_2_Rasterization_Stage, "Assets/RePiX_VR/Resources/Scenes/Stages/6.2. Rasterization Stage.unity");
            Indices.Add(OmiLAXRScene._6_2_Rasterization_Stage, 10);

            Paths.Add(OmiLAXRScene._7_1_Lighting, "Assets/RePiX_VR/Resources/Scenes/Stages/7.1. Lighting.unity");
            Indices.Add(OmiLAXRScene._7_1_Lighting, 11);

            Paths.Add(OmiLAXRScene._7_2_Lighting, "Assets/RePiX_VR/Resources/Scenes/Stages/7.2. Lighting.unity");
            Indices.Add(OmiLAXRScene._7_2_Lighting, 12);

            Paths.Add(OmiLAXRScene._8_1_Texturing_Stage, "Assets/RePiX_VR/Resources/Scenes/Stages/8.1. Texturing Stage.unity");
            Indices.Add(OmiLAXRScene._8_1_Texturing_Stage, 13);

            Paths.Add(OmiLAXRScene._8_2_Texturing_Stage, "Assets/RePiX_VR/Resources/Scenes/Stages/8.2. Texturing Stage.unity");
            Indices.Add(OmiLAXRScene._8_2_Texturing_Stage, 14);

            Paths.Add(OmiLAXRScene._9_Visibility_Test_Stage, "Assets/RePiX_VR/Resources/Scenes/Stages/9. Visibility Test Stage.unity");
            Indices.Add(OmiLAXRScene._9_Visibility_Test_Stage, 15);

            Paths.Add(OmiLAXRScene._10_Image_Stage, "Assets/RePiX_VR/Resources/Scenes/Stages/10. Image Stage.unity");
            Indices.Add(OmiLAXRScene._10_Image_Stage, 16);
        }

        public static string Path(this OmiLAXRScene scene) =>
            Paths[scene];

        public static int Index(this OmiLAXRScene scene) =>
            Indices[scene];

        public static bool IsLoaded(this OmiLAXRScene scene, bool fullyLoaded = true)
        {
            for (var i = 0; i < SceneManager.sceneCount; i++)
                if ((OmiLAXRScene)SceneManager.GetSceneAt(i).buildIndex == scene)
                    return !fullyLoaded || GetScene(scene).isLoaded;
            return false;
        }
        public static string Name(this OmiLAXRScene scene) =>
            scene.GetScene().name;

        public static Scene GetScene(this OmiLAXRScene scene) =>
            SceneManager.GetSceneByPath(scene.Path());

        public static GameObject[] GetRootGameObjects(this OmiLAXRScene scene) =>
            SceneManager.GetSceneByBuildIndex(scene.Index()).GetRootGameObjects();
    }
}